/*
Copyright (c) 2025 Mario Stöckl (mstoeck3@hs-mittweida.de). 

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>

#define BUF 1024
#define DEBUG true
#define EXPECTED_PARAMS 2


struct datetime_t {
    int year;
    int month;
    int day;
    int hour;
    int minute;
    int second;
};

struct errorLogEntry_t {
    struct datetime_t datetime;
    char level;
    int process_id;
    int state_id;
    char *connection_id_message;
};

void debugmsg(char *msg) {
    if(DEBUG==true){
        printf("DEBUG: %s\n", msg);
    }
}

int checkparams(int *argc, char *argv[]) {
    if(*argc != EXPECTED_PARAMS) {
        printf("Dateipfad anageben! Syntax: ./main <absoluter Dateipfad>\n");
        exit(-1);
    };
};

struct errorLogEntry_t parseLogline(char *logLine) {
    struct errorLogEntry_t logEntry;
    return logEntry;
};

uint32_t my_strlen(char *s) {
    uint32_t counter = 0;
    while (s[counter] != '\0') {
        counter++;
    }
    return counter;
}

int main(int argc, char *argv[]) {
    debugmsg("START OF PROGRAM");
    int i = 0;
    while(i<argc){
        char msg[BUF];
        sprintf(msg,"Argument %d: %s, Speicheradresse: %p\n", i, argv[i], &argv[i]);
        debugmsg(msg);
        i++;
    };
    checkparams(&argc,  argv);
    char *filepath = argv[1];
    FILE *fp = fopen(filepath, "r");
    if(fp == NULL) {
        perror("fopen");
        printf("Scheisse gelaufen mit der Datei...\n");
        return -1;
    }else{
        char msg[BUF];
        fseek(fp, 0L, SEEK_END);
        long filesize = ftell(fp);
        sprintf(msg, "Datei %s geöffnet. Speicheradresse %p, Speichergröße %ld\n", filepath, &fp, filesize);
        debugmsg(msg);
    }
    debugmsg("END OF PROGRAM");
    return 0;
}